Package weka.attributeSelection

# Class ExhaustiveSearch

java.lang.Object
weka.attributeSelection.ASSearch
weka.attributeSelection.ExhaustiveSearch

All Implemented Interfaces:
  `Serializable`, `OptionHandler`, `RevisionHandler`

public class ExhaustiveSearch extends ASSearch implements OptionHandler
ExhaustiveSearch :
Performs an exhaustive search through the space of attribute subsets starting from the empty set of attrubutes. Reports the best subset found.

Valid options are:

     -V
      Output subsets as the search progresses.
      (default = false).

Version:
  $Revision: 1.15 $
Author:
  Mark Hall (mhall@cs.waikato.ac.nz)
See Also:
  - Serialized Form

## Constructor Summary

Constructors
Constructor
Description
`ExhaustiveSearch()`
Constructor

## Method Summary

Modifier and Type
Method
Description
`String[]`
`getOptions()`
Gets the current settings of RandomSearch.
`String`
`getRevision()`
Returns the revision string.
`boolean`
`getVerbose()`
get whether or not output is verbose
`String`
`globalInfo()`
Returns a string describing this search method
`Enumeration`
`listOptions()`
Returns an enumeration describing the available options.
`int[]`
`search(ASEvaluation ASEval, Instances data)`
Searches the attribute subset space using an exhaustive search.
`void`
`setOptions(String[] options)`
Parses a given list of options.
`void`
`setVerbose(boolean v)`
set whether or not to output new best subsets as the search proceeds
`String`
`toString()`
prints a description of the search
`String`
`verboseTipText()`
Returns the tip text for this property

### Methods inherited from class weka.attributeSelection.ASSearch

`forName, makeCopies`

### Methods inherited from class java.lang.Object

`equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

## Constructor Details

### ExhaustiveSearch

public ExhaustiveSearch()
Constructor

## Method Details

### globalInfo

public String globalInfo()
Returns a string describing this search method

Returns:
  a description of the search suitable for displaying in the explorer/experimenter gui

### listOptions

public Enumeration listOptions()
Returns an enumeration describing the available options.

Specified by:
  `listOptions` in interface `OptionHandler`
Returns:
  an enumeration of all the available options.

### setOptions

public void setOptions(String[] options) throws Exception
Parses a given list of options.

Valid options are:

     -V
      Output subsets as the search progresses.
      (default = false).

Specified by:
  `setOptions` in interface `OptionHandler`
Parameters:
  `options` - the list of options as an array of strings
Throws:
  `Exception` - if an option is not supported

### verboseTipText

public String verboseTipText()
Returns the tip text for this property

Returns:
  tip text for this property suitable for displaying in the explorer/experimenter gui

### setVerbose

public void setVerbose(boolean v)
set whether or not to output new best subsets as the search proceeds

Parameters:
  `v` - true if output is to be verbose

### getVerbose

public boolean getVerbose()
get whether or not output is verbose

Returns:
  true if output is set to verbose

### getOptions

public String[] getOptions()
Gets the current settings of RandomSearch.

Specified by:
  `getOptions` in interface `OptionHandler`
Returns:
  an array of strings suitable for passing to setOptions()

### toString

public String toString()
prints a description of the search

Overrides:
  `toString` in class `Object`
Returns:
  a description of the search as a string

### search

public int[] search(ASEvaluation ASEval, Instances data) throws Exception
Searches the attribute subset space using an exhaustive search.

Specified by:
  `search` in class `ASSearch`
Parameters:
  `ASEval` - the attribute evaluator to guide the search
  `data` - the training instances.
Returns:
  an array (not necessarily ordered) of selected attribute indexes
Throws:
  `Exception` - if the search can't be completed

### getRevision

public String getRevision()
Returns the revision string.

Specified by:
  `getRevision` in interface `RevisionHandler`
Overrides:
  `getRevision` in class `ASSearch`
Returns:
  the revision